%type = @getthistype

if %type="NONE" then
	@uiprompt("P")
	stop
endif

'Revisar si el objeto es un grupo
if %type<>"GROUP" then
	@uiprompt("procedure can only be run from a group object")
	stop
endif

'Strings
%name= _this.@name
%metodo= "A"

if @len(%name)=0 then
	%name = "Untitled"
endif
%title = "seasonal adjustment of" + %name
if @ispanel = 1 then
	@uiprompt("The procedure is not designed for panel data")
	stop
endif
scalar check1
scalar check2
scalar check3
scalar check4=1
%title="Seasonal Adjustment"
%texto="Series components:"
!result = @uidialog("edit", %name, "Name of the group","edit", %metodo, "Method (A,M,P,L)","Text",%texto,"Check",check1,"Matrix TC","Check",check2,"Matrix IR","Check",check3,"Matrix SF","Check",check4,"Matrix SA" ,"caption", %title)
	if !result=-1 then
delete check1
delete check2
delete check3
delete check4
		stop
endif

if @isobject(%name) then
group group01 {%name}
else
@uiprompt("Error the object does not exist")
delete check1
delete check2
delete check3
delete check4
stop
endif
stomna(group01,matriz)

scalar numero_variables=@columns(matriz)

for !i=1 to numero_variables
vector v{!i}=@columnextract(matriz,!i)
next

for !i=1 to numero_variables
mtos(v{!i},se0{!i})
next

for !i=1 to numero_variables
setmaxerrs 2
se0{!i}.x12(mode={%metodo},save="d10 d11 d12 d13") se0{!i}
scalar error=@errorcount
if error=1 then
@uiprompt("Invalid method,negative data or breaks in sample please choose one of the following (A,M,P,L)")
stop
endif
next

if check1=1 then
   group grupo_tc se01_tc

   for !i=2 to numero_variables
     group grupo_tc  grupo_tc se0{!i}_tc
   next
stomna(grupo_tc,matriz_tc)
delete grupo_tc
endif

if check3=1 then
   group grupo_sf se01_sf

   for !i=2 to numero_variables
     group grupo_sf  grupo_sf se0{!i}_sf
   next
stomna(grupo_sf,martiz_sf)
delete grupo_sf
endif

if check4=1 then
   group grupo_sa se01_sa

   for !i=2 to numero_variables
     group grupo_sa  grupo_sa se0{!i}_sa
   next
stomna(grupo_sa,matriz_sa)
delete grupo_sa
endif

if check2=1 then
   group grupo_ir se01_ir

   for !i=2 to numero_variables
     group grupo_ir  grupo_ir se0{!i}_ir
   next
stomna(grupo_ir,matriz_ir)
delete grupo_ir
endif


'Borrar series y vectores
for !i=1 to numero_variables
   delete v{!i}
   delete se0{!i}
   delete se0{!i}_ir
   delete se0{!i}_sa
   delete se0{!i}_sf
   delete se0{!i}_tc
next
delete numero_variables
delete matriz
delete group01
delete error
for !i=1 to 4
   delete check{!i}
next
